/* 
*
*  ProLinga-Run
*
*  Copyright (C) 2002-2009 Xobas Software.
*  All rights reserved.
*  
*  This file is part of ProLinga-Run.
*
*  ProLinga-Run is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  ProLinga-Run is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with ProLinga-Run.  If not, see <http://www.gnu.org/licenses/>.
*
*  More information is available at the following addresses:
*
*  Website     : http://www.prolinga.org
*
*  Email       : prolinga-list@prolinga.org
*
*
*/

#include "RunCommon.h"
#include "DataRef.hpp"
#include "Logic.hpp"
#include "DataCommand.hpp"

extern ForCountStackPtr forStackPtr;
extern DataModelPtr dmPtr;

/* Command : FOREACH */
/* Syntax  : FOREACH data_model_name */
short CmdForeach(const char **argList, int argHits, bool isMainThread)
{
	char dmName[32];
	int count, step, end, retStatus;

	/* Get Data Model Name */
	getDataRef(argList[1], isMainThread, dmName, false);

	/* Always start with the first entry of the data model */
	count = 1;
	dmPtr->putCurrentRow(&dmPtr, dmName, count);

	/* Get End Value */
	end = dmPtr->getRows(dmPtr, dmName);

	/* Check if loop has to be started at all */
	if (count > end)
		return 1;

	/* Step Value is always 1 */
	step = 1;
	
	/* Create new FOR stack entry */
	forStackPtr->push(&forStackPtr, NULL, count, end, step, dmName);

	/* Get First row of Data Model */
	retStatus = dataDataModelGetRow(dmName, 1);

	/* Return */
	return 0;
}

